<?php
/*======================================================================*\
|| #################################################################### ||
|| # mh_fl - Forum Language - by MarcoH64
|| # ---------------------------------------------------------------- # ||
|| #################################################################### ||
\*======================================================================*/

// ######################## SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// ##################### DEFINE IMPORTANT CONSTANTS #######################

// #################### PRE-CACHE TEMPLATES AND DATA ######################
$phrasegroups = array('forum');
$specialtemplates = array();

// ########################## REQUIRE BACK-END ############################
require_once('./global.php');
require_once(DIR . '/includes/adminfunctions_forums.php');

// ######################## CHECK ADMIN PERMISSIONS #######################
if (!can_administer('canadminforums'))
{
	print_cp_no_permission();
}

// ############################# LOG ACTION ###############################


$vbulletin->input->clean_array_gpc('r', array(
	'languageid' 	=> TYPE_UINT
));

log_admin_action();

// ########################################################################
// ######################### START MAIN SCRIPT ############################
// ########################################################################

print_cp_header($vbphrase['mh_fl_manager']);

if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'selectlanguage';
}

// ###################### Start selectlanguage #######################
if ($_REQUEST['do'] == 'selectlanguage')
{
	if (count($vbulletin->datastore->registry->languagecache) == 0)
	{
		print_stop_message('mh_fl_no_language');
	}
	
	$languages = array();
	foreach ($vbulletin->datastore->registry->languagecache AS $key=>$value)
	{
		$languages["$key"] = $value['title'];
	}
	
	print_form_header('mh_fl_manager', 'modify');
	print_table_header($vbphrase['mh_fl_select_language']);
	print_select_row($vbphrase['language'], 'languageid', $languages, $vbulletin->GPC['languageid']);
	print_submit_row($vbphrase['continue'], null);
}

// ###################### Start modify #######################
if ($_REQUEST['do'] == 'modify')
{
	if (!$vbulletin->GPC['languageid'])
	{
		print_stop_message('mh_fl_invalid_language');
	}
	
	// Retrieve all forums with their titles
	$forum_title = array();
	foreach ($vbulletin->datastore->registry->forumcache AS $key=>$value)
	{
		$forum_title["$key"]['title'] = $value['title'];
		$forum_title["$key"]['description'] = $value['description'];
	}
	
	// Retrieve all translated forum titles for this language
	$fl_titles = $vbulletin->db->query_read("SELECT * FROM " . TABLE_PREFIX . "mh_fl_forum_language
				WHERE languageid = " . $vbulletin->GPC['languageid'] . "
			");
	while ($fl_title = $vbulletin->db->fetch_array($fl_titles))
	{
		$forum_title["$fl_title[forumid]"]['title_trans'] = $fl_title['title'];
		$forum_title["$fl_title[forumid]"]['description_trans'] = $fl_title['description'];
	}

	// Spit out the page	
	print_form_header('mh_fl_manager', 'update');
	construct_hidden_code('languageid', $vbulletin->GPC['languageid']);
	print_table_header(construct_phrase($vbphrase['mh_fl_translate_language_x'], $vbulletin->datastore->registry->languagecache[$vbulletin->GPC['languageid']]['title']));
	print_cells_row(array($vbphrase['mh_fl_original'], $vbphrase['mh_fl_translation']), true);
	foreach ($forum_title AS $forumid=>$value)
	{
		print_input_row("<a href=\"../forumdisplay.php?forumid=$forumid\" target=\"_blank\">" . $value['title'] . "</a>", "translation[$forumid][title]", $value['title_trans'], true, 100, 100);
		fetch_row_bgclass();
		print_textarea_row($value['description'], "translation[$forumid][description]", $value['description_trans'], 2, 100);
	}
	print_submit_row($vbphrase['save']);

}

// ###################### Start update #######################
if ($_POST['do'] == 'update')
{
	$vbulletin->input->clean_array_gpc('p', array(
		'translation'				=> TYPE_ARRAY_ARRAY
	));

	if (!$vbulletin->GPC['languageid'])
	{
		print_stop_message('mh_fl_invalid_language');
	}
	
	// Remove old translations
	$vbulletin->db->query_write("DELETE FROM " . TABLE_PREFIX . "mh_fl_forum_language
				WHERE languageid = " . $vbulletin->GPC['languageid'] . "
			");

	// Add new translations
	foreach ($vbulletin->GPC['translation'] AS $forumid=>$value)
	{
		if (trim($value['title']))
		{
			$vbulletin->db->query_write("INSERT INTO " . TABLE_PREFIX . "mh_fl_forum_language
						(forumid, languageid, title, title_clean, description, description_clean)
					VALUES
						(	$forumid
						,	" . $vbulletin->GPC['languageid'] . "
						,	'" . $db->escape_string($value['title']) . "'
						,	'" . $db->escape_string(htmlspecialchars_uni(strip_tags($value['title']))) . "'
						,	'" . $db->escape_string($value['description']) . "'
						,	'" . $db->escape_string(htmlspecialchars_uni(strip_tags($value['description']))) . "'
						)
				");
		}
	}
	
	// Rebuild Datastore
	require_once(DIR . '/includes/adminfunctions_mh_fl.php');
	mh_fl_rebuild_datastore();

	define('CP_REDIRECT', "mh_fl_manager.php?do=modify&amp;languageid=" . $vbulletin->GPC['languageid']);
	print_stop_message('mh_fl_saved_x_forum_titles_successfully', $vbulletin->datastore->registry->languagecache[$vbulletin->GPC['languageid']]['title']);
}

print_cp_footer();

?>
